const axios = require('axios')
const events = require("events");
const emitter = new events.EventEmitter();

let api = ''
// 页数
let page = 1
// 博客数据
let list = []
// 用户名
// let userName = null
// 读取到那个用户
let completedUserIndex = 0

// 获取所有博客数据
function GetUserInfo(names) {

  api = `https://blog.csdn.net/community/home-api/v1/get-business-list?page=${page}&size=100&businessType=lately&noMore=false&username=${names[completedUserIndex]}`

  axios.get(api).then(val => {
    if (val.status == 200 && val.statusText == 'OK' && val.data.data.list != null) {
      page++

      val.data.data.list.forEach(item => {
        delete item.type
        delete item.description
        delete item.formatTime
        delete item.hasOriginal
        delete item.diggCount
        delete item.commentCount
        delete item.postTime
        delete item.createTime
        delete item.articleType
        delete item.rtype
        if (item.title && item.url && item.viewCount) {
          list.push(item)
        }
      })
      // 递归
      GetUserInfo(names)
    } else {
      if (completedUserIndex < names.length - 1) {
        completedUserIndex++
        // 重置
        page = 1
        userName = null
        // 递归 当前用户已完成
        GetUserInfo(names)
      } else {
        if (list.length == 0) {
          console.log("该用户没有文章！".red, "用户名称：" + names[completedUserIndex]);
          // process.exit(1)
        } else {
          // 以获取全部，发送数据
          emitter.emit("loadListCompleted", list);
        }


      }
    }
  }, reason => {
    console.log('Error', reason);
    reject(reason)
  })


}

// 导出
module.exports = {
  GetUserInfo,
  emitter,
};